# Fetchio
Simple wrapper over window.fetch

# How to use
### Include to project
#### Global
```html
<script src="node_modules/fetchio/dist/main.bundle.js"></script>
<script>
    var fetchio = fetchio.default;
</script>
```
#### CommonJS
```js
var fetchio = require('fetchio')['default'];
```
### ES6
```ecmascript 6
import fetchio from 'fetchio'
```

### Usage
```ecmascript 6
const Api = fetchio.Init({
  baseUrl: 'https://api.example.com',
  requestInterceptor: function (req) {
    // do some stuff
    return req
  },
  fetch: {/*...*/}
})
```

```ecmascript 6
Api.Fetch('users', { headers: {/*...*/} }, { userId: 1 })
// GET https://api.example.com/users?userId=1
// return Promise
```

```ecmascript 6
Api.Fetch('users', {
  method: 'post',
  body: JSON.stringify(user)
})
// POST https://api.example.com/users
// return Promise
```

## Dependencies
* whatwg-fetch
* url-join

## License
MIT
