import {
  appendQueryStringToURL,
  objectToQueryString
} from './helpers'
import defaultConfig from './configuration'
import {
  BUILD_URL
} from './symbols'
import 'whatwg-fetch'
import urlJoin from 'url-join'

export default class Client {
  static Init (config) {
    this.config = Object.assign({}, defaultConfig, config)
    return this
  }

  static Fetch (url = '', fetchOptions = {}, queryParams = {}) {
    let fullUrl = this[BUILD_URL](url, queryParams)
    let fullObj = Object.assign({}, defaultConfig.fetch, fetchOptions)

    if (typeof this.config.requestInterceptor === 'function') {
      fullObj = this.config.requestInterceptor(fullObj)
    }

    let req = new Request(fullUrl, fullObj)

    return fetch(req)
  }

  static [BUILD_URL] (url, queryParams) {
    return urlJoin(this.config.baseUrl, appendQueryStringToURL(url, objectToQueryString(queryParams)))
  }
}
